package numarea;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/* ================================================================
 *  ファイル　ダイアログ
 */
public class ControlDialog extends JDialog implements ActionListener, ItemListener
{	
	private GridField 		gridfield;
	private JTabbedPane 	tabbedpane;	

	final	DesignPanel		designPage;
	final	MakePanel		makePage;
	final	GraphPanel		graphPage;
	final	ShapePanel		shapePage;	
	final	Component		difficultyPage;
	
	public ControlDialog(GridField grid) {	
	
		this.gridfield = grid;
		
		this.setModal(false);
		this.setTitle("Number Area Problem Generator");
		Container container = this.getContentPane();
		tabbedpane = new JTabbedPane();
		container.add(tabbedpane);
		
		tabbedpane.addTab("基本",		designPage = new DesignPanel(gridfield,this) );
		tabbedpane.addTab("難度",   	difficultyPage = new DifficultyPanel(gridfield) );
		tabbedpane.addTab("作成",  	makePage = new MakePanel(gridfield) );
		tabbedpane.addTab("グラフ",  	graphPage = new GraphPanel(gridfield) );
		tabbedpane.addTab("形状",  	shapePage = new ShapePanel(gridfield) );		
		
		// Register a change listener
		tabbedpane.addChangeListener(new ChangeListener() {
		    // This method is called whenever the selected tab changes
		    public void stateChanged(ChangeEvent evt) {
		    	JTabbedPane pane = (JTabbedPane)evt.getSource();

		    	// Get current tab
		    	Component currentpage = pane.getSelectedComponent();
		    	if( currentpage == shapePage ) {
		    		shapePage.updateShapeTable();
		    	}
		    }
		});
		
		pack();
	}
	
	public void showDialog(){
		this.setVisible(true);
	}

	@Override
	public void itemStateChanged(ItemEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		
	}
}

