package numarea;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.ItemSelectable;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

/* ================================================================
 *  デザイン パネル
 */
public class DesignPanel extends JPanel implements ActionListener, ItemListener
{	
	private static final int WIDTHLIMIT = 150;
	private static final int HEIGHTLIMIT = 150; 

	private GridField			gridfield;
	private ControlDialog	controldialog;

	private JButton  showButton 	= new JButton("Front");
	
	private String	filenameXML	= null;
	
	private JLabel	filepathLabel	= new JLabel("file name");
	private JButton	loadButton 	= new JButton("load");
	private JButton 	saveButton		= new JButton("save");
	private JButton	loadgifButton	= new JButton("load gif");
	
	private JLabel  unitLabel    	= new JLabel( " xx " );
	private JButton plus1Button 	= new JButton("+1");
	private JButton minus1Button 	= new JButton("-1");
	private JButton zoominButton 	= new JButton("Zoom In");
	private JButton zoomoutButton 	= new JButton("Zoom Out");

	private JButton resizeButton 	= new JButton("OK");
	private JTextField wText 		= new JTextField();
	private JTextField hText 		= new JTextField();
	public	void	setwText( String str ) {		wText.setText(str);	}
	public	void	sethText( String str ) {		hText.setText(str);	}

	private JButton copyButton		= new JButton("Copy");
	private JButton pasteButton		= new JButton("Paste");
	private JButton clearBuffer		= new JButton("Clear");	
	
	private JCheckBox  recdivCheck 		= new JCheckBox("recdiv",false);
	private JTextField recdivlimitText = new JTextField("100", 4);
	private JTextField recdivtryText 	= new JTextField("5", 2);
	
	public		boolean	isrecdivyon()	{	return	recdivCheck.isSelected();	}
	public	int	getrecdivlimit()	{	return	Integer.valueOf(	recdivlimitText.getText());	}	
	public	int	getrecdivtry() 	{	return	Integer.valueOf(	recdivtryText.getText());	}	
	public		void	setrecdivyon( boolean b )	{	recdivCheck.setSelected(b);		}
	public		void	setrecdivlimit( int v )		{	recdivlimitText.setText(""+v);	}
	public		void	setrecdivtry( int v )		{	recdivtryText.setText(""+v);	}
	
	private	JTextField		restcountweightfield	= new JTextField("1.0",5);
	public	double	getrestcountweight() 	{	return	Double.valueOf(restcountweightfield.getText());	}
	public	void	setrestcountweight( double v )		{	restcountweightfield.setText(""+v);	}

	private	JTextField		mdivcountweightfield	= new JTextField("10.0",5);
	public	double	getmdivcountweight() 	{	return	Double.valueOf(mdivcountweightfield.getText());	}
	public	void	setmdivcountweight( double v )	{	mdivcountweightfield.setText(""+v);	}
	
	private JButton setHidButton = new JButton("Hidden");
	private JButton clearPreButton = new JButton("Clear");
	private	JTextField		prefixweightfield	= new JTextField("1.0",5);
	public	double	getprefixweight() 	{	return	Double.valueOf(prefixweightfield.getText());	}
	public	void	setprefixweight( double v )		{	prefixweightfield.setText(""+v);	}
	
	private JButton setNumButton = new JButton("Number");
	private JButton clearNumButton = new JButton("Clear");
	private	JTextField		prenumweightfield	= new JTextField("1.0",5);
	public	double	getprenumweight() 	{	return	Double.valueOf(prenumweightfield.getText());	}	
	public	void	setprenumweight( double v )		{	prenumweightfield.setText(""+v);	}
	
	private JCheckBox rotate2Check 	= new JCheckBox("Rotate 180");
	private JCheckBox vaxisCheck 	= new JCheckBox("vertical axis");
	private JCheckBox haxisCheck 	= new JCheckBox("horizontal axis");
	
	public	boolean	isrotate2()				{	return	rotate2Check.isSelected();	}
	public	void		setrotate2( boolean b ) 	{	rotate2Check.setSelected(b);	}
	public	boolean	isvaxis()					{	return	vaxisCheck.isSelected();	}
	public	void		setvaxis( boolean b ) 	{	vaxisCheck.setSelected(b);	}
	public	boolean	ishaxis()					{	return	haxisCheck.isSelected();	}
	public	void		sethaxis( boolean b ) 	{	haxisCheck.setSelected(b);	}
	
	private int width , height;
	private SymmetricProperty symmetry;
	
	DesignPanel(GridField grid,ControlDialog cd) {
		this.gridfield = grid;
		this.controldialog = cd;
		grid.designpanel = this;
		symmetry = gridfield.symmetry;
		
		this.width = grid.getGridSize().width;
		this.height = grid.getGridSize().height;
		wText.setText(Integer.toString(width));
		wText.setColumns(3);
		hText.setText(Integer.toString(height));
		hText.setColumns(3);

		setLayout(new BorderLayout());	
		
		// 上(File)
		JPanel filepanel = makeFilepanel();
		filepanel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		add(filepanel,"North");

		// 中央
		JPanel centerpanel = new JPanel();
		centerpanel.setLayout( new  BoxLayout(centerpanel,BoxLayout.Y_AXIS) );
		add(centerpanel,"Center");
		centerpanel.add(makeSizePanel());		
		centerpanel.add(makeUnitPanel());
		centerpanel.add(makeZoomPanel());
		centerpanel.add(makeCopyPanel());
		centerpanel.add(makeRecdivPanel());
		
		// 右（対称性）
		JPanel symmetrypanel = makeSymmetryPanel();
		add(symmetrypanel,"East");

		// 下(South)
		JPanel bottompanel = new JPanel();	
		bottompanel.setLayout( new  BoxLayout(bottompanel,BoxLayout.Y_AXIS) );
		add(bottompanel,"South");
		
		bottompanel.add(makeRestCountPanel());			// 未決定マス係数
		bottompanel.add(makePreNumPanel());			// 数字指定
		bottompanel.add(makePresetPanel());			// 隠し絵
		
		resizeButton.addActionListener(this);
	}
	
	//---------------------------------------------------------------
	//　File Panel
	private JPanel makeFilepanel() {
		JPanel toppanel = new JPanel();
		toppanel.setLayout(new GridLayout(2,1));
	
		// line 1
		toppanel.add(filepathLabel);				// ファイル名
		
		// line 2
		JPanel saveloadpanel = new JPanel();
		saveloadpanel.setLayout(new FlowLayout());
		toppanel.add(saveloadpanel);
		
		saveloadpanel.add(loadButton);	
		loadButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.PLAY);
						gridfield.clearSolverButton();
						File file = FileIO.getloadFile(gridfield,controldialog);
						if( file == null )
							return;
						loadFile(file);
					}
				}
		);
		
		saveloadpanel.add(saveButton);
		saveButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						FileIO.saveFile(gridfield,controldialog);
						filepathLabel.setText(filenameXML = FileIO.pathname);
						gridfield.mainpanel.setFilename(new File (filenameXML).getName());
					}
				}
		);	
		
		saveloadpanel.add(new JLabel("    "));	

		saveloadpanel.add(loadgifButton);	
		loadgifButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.INIT);
						gridfield.clearSolverButton();
						File file = FileIO.getloadGifFile(gridfield,controldialog);
						loadGifFile(file);
					}
				}
		);
		
		return	toppanel;
	}
	
	private void loadFile( File file ) {
		if( file == null )
			return;
		FileIO.loadFile(file);
		filepathLabel.setText(filenameXML = FileIO.pathname);
		gridfield.setDifficultypoint(FileIO.savedPoint);
		gridfield.mainpanel.setFilename(file.getName());
	}
	
	private void loadGifFile( File file ) {
		if( file == null )
			return;
		FileIO.loadGifFile(file);		
 		setwText(""+gridfield.getBWidth());
 		sethText(""+gridfield.getBHeight());
		setrotate2(false);
		FileIO.loadGifFile(file);
	}
	
	//---------------------------------------------------------------
	// 基本部分
	private JPanel makeSizePanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());	
	
		panel.add(showButton);
		showButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.mainpanel.mainframe.toFront();
					}
				}
		);
		
		panel.add(new JLabel("width"));
		panel.add(wText);
		panel.add(new JLabel("height"));
		panel.add(hText);
		panel.add(resizeButton);
		
		return	panel;
	}
	
	private JPanel makeUnitPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(unitLabel);
		updateUnitLabel();
		panel.add(plus1Button);
		
		plus1Button.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.zoom(1);
						updateUnitLabel();
					}
				}
		);
		panel.add(minus1Button);
		minus1Button.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.zoom(-1);
						updateUnitLabel();
					}
				}
		);
		
		return	panel;
	}
	
	private JPanel makeZoomPanel() {
		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());
		
		panel.add(zoominButton);
		zoominButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.zoomIn();
						updateUnitLabel();
					}
				}
		);
		panel.add(zoomoutButton);
		zoomoutButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.zoomOut();
						updateUnitLabel();
					}
				}
		);	
		
		return	panel;
	}
	
	private JPanel makeCopyPanel() {
		JPanel panel = new JPanel();
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		panel.setLayout(new FlowLayout());
		
		panel.add(copyButton);
		copyButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.copybuffer();
					}
				}
		);
		panel.add(pasteButton);
		pasteButton.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.pastebuffer();
					}
				}
		);	
		panel.add(clearBuffer);
		clearBuffer.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {
						gridfield.clearbuffer();
					}
				}
		);			

		return	panel;
	}
	
	private JPanel makeRecdivPanel() {
		JPanel panel = new JPanel();
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		panel.setLayout(new FlowLayout());
		
		panel.add(recdivCheck);
		
		panel.add( new JLabel(" "));
		
		panel.add( new JLabel("limit"));
		panel.add( recdivlimitText );
		
		panel.add( new JLabel(" "));

		panel.add( new JLabel("try"));
		panel.add( recdivtryText );
		
		return	panel;
	}
	
	private JPanel makeSymmetryPanel() {
		JPanel panel = new JPanel();
		panel.setLayout( new  BoxLayout(panel,BoxLayout.Y_AXIS) );

		rotate2Check.addItemListener(this);
		vaxisCheck.addItemListener(this);
		haxisCheck.addItemListener(this);

		panel.add(rotate2Check);
		panel.add(vaxisCheck);
		panel.add(haxisCheck);
		
		rotate2Check.setSelected(symmetry.rotate2);
		vaxisCheck.setSelected(symmetry.vaxis);
		haxisCheck.setSelected(symmetry.haxis);
		
		return panel;
	}

	//-----------------------------------------------------------------------
	//		Restcount
	//-----------------------------------------------------------------------	
	private	JPanel	makeRestCountPanel() {
		JPanel panel = new JPanel();
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));

		panel.add( new JLabel( "RestCount   *"));
		panel.add( restcountweightfield );
		
		panel.add( new JLabel( "        MDivCount   *"));
		panel.add( mdivcountweightfield );
		
		return	panel;
	}
	
	//-----------------------------------------------------------------------
	//		初期分割指定
	//-----------------------------------------------------------------------	
	private	JPanel	makePresetPanel() {	
		JPanel panel = new JPanel();	
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		
		JPanel panel2 = new JPanel();
		
		panel2.add(setHidButton);
		setHidButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.HIDDEN);							
						gridfield.refresh();
						setHidButton.setBackground(Color.green);
					}
				});		
		
		panel2.add(clearPreButton);
		clearPreButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						gridfield.clearPreShape();
						gridfield.repaint();
						setHidButton.setBackground(null);
					}
				});

	
		panel2.add(new JLabel("*"));
		panel2.add(prefixweightfield);
		
		panel.add(panel2);
		
		return	panel;
	}
	
	//-----------------------------------------------------------------------
	//		初期分割指定
	//-----------------------------------------------------------------------	
	private	JPanel	makePreNumPanel() {	
		JPanel panel = new JPanel();	
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		
		JPanel panel2 = new JPanel();
		
		panel2.add(setNumButton);
		setNumButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						gridfield.setMode(GridField.MODE.NUMBER);							
						gridfield.refresh();
						setNumButton.setBackground(Color.green);
					}
				});		
		
		panel2.add(clearNumButton);
		clearNumButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						gridfield.clearPreNumber();
						gridfield.repaint();
						setNumButton.setBackground(null);
					}
				});

		panel2.add(new JLabel("*"));
		panel2.add(prenumweightfield);
		
		panel.add(panel2);
		
		return	panel;
	}
	
	//-----------------------------------------------------------------------
	// チェックの状態変更
	//-----------------------------------------------------------------------
	public void itemStateChanged(ItemEvent e) {
		ItemSelectable item = e.getItemSelectable();
		
		if (item == rotate2Check)
			symmetry.rotate2 = rotate2Check.isSelected();
		if (item == vaxisCheck)
			symmetry.vaxis = vaxisCheck.isSelected();
		if (item == haxisCheck)
			symmetry.haxis = haxisCheck.isSelected();
		
		gridfield.checkSymmetry();
		gridfield.adjustSize();
		gridfield.refresh();		
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == resizeButton){
			try{
				int nw = new Integer(wText.getText());
				int nh = new Integer(hText.getText());
				if(nw > WIDTHLIMIT ) nw = WIDTHLIMIT;
				if(nw < 1)  nw = 1;
				if(nh > HEIGHTLIMIT) nh = HEIGHTLIMIT;
				if(nh < 1)  nh = 1;
				width=nw;
				height=nh;
				gridfield.setGridSize(width,height);
				
			}catch(NumberFormatException ex){}
		}
	}
	
	public void updateUnitLabel() {
		int u = gridfield.getUnit();
		unitLabel.setText( " " + u + " " );
	}
	
	public void showDialog(){
		this.setVisible(true);
	}
	public Dimension getInputedSize(){
		return new Dimension(width , height);
	}
	public void setInputSize( int w, int h ) {
		wText.setText(""+w);
		hText.setText(""+h);
	}
}

class SymmetricProperty{
	public boolean rotate2;		// 180 rotation
	public boolean vaxis;		// vertical axis
	public boolean haxis;		// horizontal axis

	public SymmetricProperty() {
		rotate2 	= true;
		vaxis		= false;
		haxis		= false;
	}
	public void setAll( boolean f ){
		rotate2 	= f;
		vaxis		= f;
		haxis		= f;
	}
}


