package numarea;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Arrays;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/* ================================================================
 *  難易度　パネル
 */
public class DifficultyPanel extends JPanel implements ActionListener, ItemListener,ChangeListener 
{ 
	private static final long serialVersionUID = -5978978028868379377L;

	private GridField gridfield;
	
	JCheckBox deadendCheck 		= new JCheckBox("凹");
	JCheckBox initfixhalfCheck 	= new JCheckBox("初期部分確定");
	JCheckBox pegfixhalfCheck 	= new JCheckBox("部分確定");
	JCheckBox celluniqpegCheck	= new JCheckBox("単一到達");
	JCheckBox cellcommonCheck	= new JCheckBox("離島");
	JCheckBox regiondivideCheck	= new JCheckBox("領域分割");
	public	boolean getDeadEnd()					{	return	deadendCheck.isSelected();	}
	public void	setDeadEnd( boolean s )		{	deadendCheck.setSelected(s);	}		
	public	boolean getInitFixhalf()				{	return	initfixhalfCheck.isSelected();	}
	public void	setInitfixhalf( boolean s )	{	initfixhalfCheck.setSelected(s);	}	
	public	boolean getPegFixhalf()				{	return	pegfixhalfCheck.isSelected();	}
	public void	setPegfixhalf( boolean s )	{	pegfixhalfCheck.setSelected(s);	}
	public	boolean getCelluniqpeg()				{	return	celluniqpegCheck.isSelected();	}
	public void	setCelluniqpeg( boolean s )	{	celluniqpegCheck.setSelected(s);	}
	public	boolean getCellcommon()				{	return	cellcommonCheck.isSelected();	}
	public void	setCellcommon( boolean s )	{	cellcommonCheck.setSelected(s);	}
	public	boolean getRegiondivide()			{	return	regiondivideCheck.isSelected();	}
	public void	setRegiondivide( boolean s ){	regiondivideCheck.setSelected(s);	}

	private JButton clrconstButton = new JButton("--");
	private JButton zeroconstButton = new JButton("0");
	private JButton setconstButton = new JButton("Set");
	private JButton delconstButton = new JButton("DEL");
	private	Color	elemsetcolor	= new Color(0xbf,0xee,0xee);
	private	Color	elemclkcolor	= Color.yellow;
	private	JTextField		rectweightfield = new JTextField("1.0",5);	
	public		double	getrectweight()	{	return	Double.valueOf(rectweightfield.getText());	}
	public		void	setrectweight( double d )	{	rectweightfield.setText(""+d);		}
	
	private JLabel	currentpointlabel = new JLabel( "current point" );
	public	void		setCurrentPointLabel( int v )	{	currentpointlabel.setText(""+v);	}

	public		int		lowerlimit = 0;
	public		int		upperlimit = Integer.MAX_VALUE;
	public		double	limitweight = 1.0;
	
	private	JTextField		lowerlimitfield = new JTextField();
	private	JTextField		upperlimitfield = new JTextField();
	private	JTextField		limitweightfield = new JTextField();	// 遺伝的アルゴリズムでの範囲外掛け率
	public		int		getlowerlimit()	{	return	Integer.valueOf(lowerlimitfield.getText());	}
	public		int		getupperlimit()	{	return	Integer.valueOf(upperlimitfield.getText());	}
	public		double	getlimitweight()	{	return	Double.valueOf(limitweightfield.getText());	}
	public		void	setlowerlimit( int v )		{	lowerlimitfield.setText(""+v);		}
	public		void	setupperlimit( int v )		{	upperlimitfield.setText(""+v);		}
	public		void	setlimitweight( double d )	{	limitweightfield.setText(""+d);		}
	
	private	JCheckBox 		unevenCheck			= new JCheckBox("Uneven",false);
	private	JTextField		uneventhresholdfield	= new JTextField("0.0", 4);
	private	JTextField		unevenstepfield			= new JTextField("2", 2);
	private	JTextField		unevenmaxfield			= new JTextField("0.05", 5);
	private 	JLabel 		unevencountlabel			= new JLabel("--");
	private	JTextField		unevenweightfield 	= new JTextField("1.0",5);	
	private	JButton		unevenPrint			= new JButton("P");

	public		boolean		isuneven()			{	return	unevenCheck.isSelected();	}
	public		double	getuneventhreashold()	{	return	Double.valueOf(uneventhresholdfield.getText());	}
	public		int		getunevenstep()			{	return	Integer.valueOf(unevenstepfield.getText());	}
	public		double	getunevenmaxrate()	{	return	Double.valueOf(unevenmaxfield.getText());	}
	public		double	getunevenweight()		{	return	Double.valueOf(unevenweightfield.getText());	}
	public		int		getunevenmaxcount()	{
		double rate = getunevenmaxrate();
		int	cnt = (int)(gridfield.getBWidth()*gridfield.getBHeight()*rate);
		return	cnt;
	}
	public		void	setunevencount( int v )	{
		String str = String.format( "%6.3f:%d", 
							(double)(v)/gridfield.getBWidth()/gridfield.getBHeight(), v );
		unevencountlabel.setText(str);
	}
	public		void	setunevenweight( double d )	{	unevenweightfield.setText(""+d);	}


	private	boolean	replayrunning;
	
	public		HistoryPanel 	historypanel;
	public		UnevenPanel	unevenpanel;
	
	private	JPanel	sizecontrolpanel  = new JPanel();
	private	JPanel	shapecontrolpanel = new JPanel();

	
	DifficultyPanel(GridField grid) {
		this.gridfield = grid;
		Solver solver = grid.getSolver();
		grid.difficultypanel = this;
		
		setLayout( new  BoxLayout(this,BoxLayout.Y_AXIS) );
						
		JPanel fullpanel = new JPanel();
		fullpanel.setLayout(new BorderLayout());	
		
		// 難易度パネル
		JPanel hardpanel = new JPanel();
		Difficulty usediff = solver.usedifficulty;
		hardpanel.add(deadendCheck);		deadendCheck.setSelected(usediff.deadend);		
		hardpanel.add(initfixhalfCheck);	initfixhalfCheck.setSelected(usediff.initfixhalf);		
		hardpanel.add(pegfixhalfCheck);		pegfixhalfCheck.setSelected(usediff.pegfixhalf);
		hardpanel.add(celluniqpegCheck);	celluniqpegCheck.setSelected(usediff.celluniqpeg);
		hardpanel.add(cellcommonCheck);		cellcommonCheck.setSelected(usediff.cellcommon);
		hardpanel.add(regiondivideCheck);	regiondivideCheck.setSelected(usediff.regiondivide);		
		hardpanel.setLayout(new FlowLayout());
		add(hardpanel);
		
		JPanel pointrangepanel = makePointRangePanel();
		add( pointrangepanel );
		
		historypanel = new HistoryPanel();
		add( historypanel );

		unevenpanel = new UnevenPanel();
		add( unevenpanel );
		
		// 下側
		JPanel	lowerpanel = new JPanel();
		lowerpanel.setLayout(new BorderLayout());	
		
		// 下左側
		JPanel	lwpanel = new JPanel();
		lwpanel.setLayout( new  BoxLayout(lwpanel,BoxLayout.Y_AXIS) );
		lwpanel.add(clrconstButton);
		clrconstButton.setAlignmentX(0.5f);
		lwpanel.add(zeroconstButton);
		zeroconstButton.setAlignmentX(0.5f);
		lwpanel.add(setconstButton);
		setconstButton.setAlignmentX(0.5f);
		lwpanel.add(new JLabel(" "));		// gap
		
		lwpanel.add(delconstButton);
		delconstButton.setAlignmentX(0.5f);	
		lwpanel.add(new JLabel(" "));		// gat
		
		JPanel weightpanel = new JPanel();
		weightpanel.add(new JLabel("*"));
		weightpanel.add(rectweightfield);
		lwpanel.add(weightpanel);
		
		lowerpanel.add( lwpanel, "West" );
		
		JPanel	ctrlmakepanel = new JPanel();
		
		ctrlmakepanel.add( new SizeControlPanel() );
		ctrlmakepanel.add( new ShapeControlPanel() );		
		lowerpanel.add( ctrlmakepanel, "North" );
		
		JPanel	shapecontrolpanel = makeShapeControlPanel();
		lowerpanel.add( shapecontrolpanel, "Center" );
		
		add(lowerpanel);
		
		clrconstButton.addActionListener(
				new ActionListener() {
		 	    	public void actionPerformed(ActionEvent e) {
		 	    		clearAllConstraints();
		 	    	}
		 	    });	
		zeroconstButton.addActionListener(
				new ActionListener() {
		 	    	public void actionPerformed(ActionEvent e) {
		 	    		zeroAllConstraints();
		 	    	}
		 	    });
		setconstButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						allreread();
					}
				});
		delconstButton.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						delelems();
					}
				});

		initfixhalfCheck.addItemListener(this);
		pegfixhalfCheck.addItemListener(this);
		celluniqpegCheck.addItemListener(this);
		cellcommonCheck.addItemListener(this);
		regiondivideCheck.addItemListener(this);
	}
		
	//-----------------------------------------------------------------------
	// ポイント範囲指定
	//-----------------------------------------------------------------------
	private	JPanel	makePointRangePanel() {
		JPanel panel = new JPanel();
		
		panel.add( lowerlimitfield );
		lowerlimitfield.setColumns(12);
		lowerlimitfield.setText(""+lowerlimit);
		panel.add( new JLabel("<=") );
		panel.add( currentpointlabel );
		panel.add( new JLabel("<") );		
		panel.add( upperlimitfield );
		upperlimitfield.setColumns(12);
		upperlimitfield.setText(""+upperlimit);
		
		panel.add( new JLabel ("  "));
		panel.add( new JLabel ("*"));
		panel.add( limitweightfield );
		limitweightfield.setColumns(5);
		limitweightfield.setText("1.0");

		return	panel;
	}

	//-----------------------------------------------------------------------
	//		履歴制御
	//-----------------------------------------------------------------------
	class HistoryPanel extends JPanel implements ActionListener, ItemListener,ChangeListener {

		private JButton stopButton 	= new JButton("■");
		private JButton runButton 	= new JButton("run");	
		private JButton autoButton 	= new JButton("A");
		private JButton stepButton 	= new JButton("+1");
		private JButton backButton 	= new JButton("-1");

		private JLabel sliderlabel = new JLabel();
		JSlider slider = new JSlider();

		HistoryPanel() {
			setLayout(new BorderLayout());
			setLayout( new  BoxLayout(this,BoxLayout.Y_AXIS) );
			setBorder(new EtchedBorder(EtchedBorder.LOWERED));

			JPanel	buttons = new JPanel();
			buttons.add(stopButton);
			buttons.add(runButton);	
			buttons.add(autoButton);
			buttons.add(stepButton);
			buttons.add(backButton);	
			add(buttons);

			JPanel	center = new JPanel();
			center.add(sliderlabel);
			sliderlabel.setText("--/--");
			center.add(slider);

			slider.setPreferredSize(new Dimension(300,30));
			JPanel sliderpanel = new JPanel();
			sliderpanel.add( slider );
			add(sliderpanel);

			slider.addChangeListener(this);

			stopButton.addActionListener(this);
			runButton.addActionListener(this);	    
			autoButton.addActionListener(this);
			stepButton.addActionListener(this);
			backButton.addActionListener(this);
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == stopButton) {	execStop();
			} else if(e.getSource() == runButton) 	{	execRun();		
			} else if(e.getSource() == autoButton) {	execAuto();
			} else if(e.getSource() == stepButton) {	execStep();
			} else if(e.getSource() == backButton) {	execBack();
			}
		}

		@Override
		public void itemStateChanged(ItemEvent e) {
		}

		// slider の　リスナー
		public void stateChanged(ChangeEvent e) {

			int val = (int)slider.getValue();
			int max = slider.getMaximum();
			sliderlabel.setText( val + "/" + max );

			gridfield.replay(val);
		}

		public void setslidersize( int len ) {
			slider.setMaximum(len);
			slider.setValue(len);
		}

		private void execStop() {
			replayrunning = false;
		}

		private void execStep() {
			if( replayrunning )
				return;

			int max = slider.getMaximum();
			int val = (int)slider.getValue();
			if( val >= max )
				return;

			++val;
			gridfield.replay(val);

			slider.setValue(val);
		}

		private void execBack() {
			if( replayrunning )
				return;
			int val = (int)slider.getValue();
			if( --val >= 0) {
				gridfield.replay(val);
				slider.setValue(val);
			}
		}

		private void execRun() {
			if( replayrunning )
				return;

			slider.setValue(0);
			execAuto();
		}

		private void execAuto() {
			if( replayrunning )
				return;

			Thread th = new Thread() {
				public void run() {
					replayrunning = true;
					int max = slider.getMaximum();
					int val = (int)slider.getValue();

					while( replayrunning &&  ++val <= max ) {     			
						try{	Thread.sleep(200);	
						} catch( InterruptedException e ) {}

						gridfield.replay(val);       			

						slider.setValue(val);
					}
					replayrunning = false;
				}
			};
			th.start();
		}
	}
	
	//-----------------------------------------------------------------------	
	// パネル　偏り
	//-----------------------------------------------------------------------	
	class	UnevenPanel extends JPanel {
		private static final long serialVersionUID = -1L;

		UnevenPanel() {			
			add( unevenCheck );
			
			add( new JLabel("  th") );
			add( uneventhresholdfield );
			add( new JLabel("  step") );
			add( unevenstepfield );
			add( new JLabel("<=") );
			add( unevenmaxfield );
			add( new JLabel("  ") );
			add( unevencountlabel );
			
			add( new JLabel("  *") );
			add( unevenweightfield );
			
			add( new JLabel("  ") );
			add( unevenPrint );				// コンソール印字ボタン
			
			unevenPrint.addActionListener(
					new ActionListener() {
			 	    	public void actionPerformed(ActionEvent e) {
			 	    		gridfield.getlumpcount();
			 	    	}
			 	    });	
		}
	}
	
	//-----------------------------------------------------------------------	
	// サイズ制御要素パネルの生成
	//-----------------------------------------------------------------------	
	class SizeControlPanel extends JPanel {		
		int		area = -1;
		final String[] cmpselectionsStr = { "=", "<=", ">="};
		JComboBox areacombo	= new JComboBox(cmpselectionsStr);	
		JTextField makesizefield = new JTextField();
		JComboBox cntcombo	= new JComboBox(cmpselectionsStr);			
		JButton make = new JButton("Add");

		SizeControlPanel() {
			setBorder(new EtchedBorder(EtchedBorder.LOWERED));

			add(new JLabel("(Area"));

			areacombo.addActionListener(
					new ActionListener(){
						public void actionPerformed(ActionEvent e) {
							JComboBox combo = (JComboBox)e.getSource();
							String str = combo.getSelectedItem().toString();
						}
					});
			areacombo.setSelectedIndex(0);
			add(areacombo);

			makesizefield.setText("--");
			makesizefield.setColumns(2);
			add(makesizefield);

			add(new JLabel(")"));
			add(new JLabel("count"));

			cntcombo.addActionListener(
					new ActionListener(){
						public void actionPerformed(ActionEvent e) {
							JComboBox combo = (JComboBox)e.getSource();
							String str = combo.getSelectedItem().toString();
						}
					});
			cntcombo.setSelectedIndex(0);
			add(cntcombo);

			add(make);
			make.addActionListener(
					new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							addSizeControlElement();
						}
					});
		}
		
		private	void	addSizeControlElement() {
			String str = makesizefield.getText();
			try {
				area = new Integer(str);
			}catch(NumberFormatException ex){
				area = -1;
				makesizefield.setText("--");
			}
			String areacmpstr = areacombo.getSelectedItem().toString();
			String cntcmpstr 	= cntcombo.getSelectedItem().toString();

			addAreaConstraint( sizecontrolpanel, area, areacmpstr, cntcmpstr );
		}
	}
	
	//--------------------------------------------------------------------------------
	// 形状制御要素パネルの生成　(ll x sl)
	//--------------------------------------------------------------------------------
	class ShapeControlPanel extends JPanel {
		private static final long serialVersionUID = -5978978028868379378L;
		
		final String[] cmpselectionsStr = { "=", "<=", ">="};
		JComboBox areacombo	= new JComboBox(cmpselectionsStr);	
		JTextField longsidefield = new JTextField();
		JTextField shortsidefield = new JTextField();
		JComboBox cntcombo	= new JComboBox(cmpselectionsStr);			
		JButton make = new JButton("Add");

		ShapeControlPanel() {
			setBorder(new EtchedBorder(EtchedBorder.LOWERED));

			add(new JLabel("("));

			longsidefield.setText("--");
			longsidefield.setColumns(2);
			add(longsidefield);
			
			add(new JLabel("x"));
			
			shortsidefield.setText("--");
			shortsidefield.setColumns(2);
			add(shortsidefield);

			add(new JLabel(")"));
			add(new JLabel("count"));

			cntcombo.addActionListener(
					new ActionListener(){
						public void actionPerformed(ActionEvent e) {
							JComboBox combo = (JComboBox)e.getSource();
							String str = combo.getSelectedItem().toString();
						}
					});
			cntcombo.setSelectedIndex(0);
			add(cntcombo);

			add(make);
			make.addActionListener(
					new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							addSizeControlElement();
						}
					});
		}
		
		private	void	addSizeControlElement() {
			String strl = longsidefield.getText();
			String strs = shortsidefield.getText();
			int	ls = -1;
			int ss = -1;

			try {
				 ls = new Integer(strl);
			}catch(NumberFormatException ex){
				ls = -1;
				longsidefield.setText("--");
			}
			try {
				 ss = new Integer(strs);
			}catch(NumberFormatException ex){
				ss = -1;
				shortsidefield.setText("--");
			}	
			if( ls == -1 || ss == -1 )
				return;
			
			String cntcmpstr 	= cntcombo.getSelectedItem().toString();

			addShapeConstraint( shapecontrolpanel, ls, ss, cntcmpstr );
		}
	}
	
	//--------------------------------------------------------------------------------
	
	ArrayList<ConstraintElem>	shapeconstraintlist = new ArrayList<ConstraintElem>();
	
	public	boolean	isOkShape( Rectangle rec ) {
		Point	peg = gridfield.getPeg( rec );
		if( peg == null )
			return	false;
		int	bwidth = gridfield.getBWidth();
		int bheight = gridfield.getBHeight();
		return	isOkShape( rec, !Util.isInside( peg, bwidth, bheight ));
	}
	
	public	boolean	isOkShape( Rectangle rec, boolean onboard ) {
		boolean	isok = true;
		for( ConstraintElem elem : shapeconstraintlist ) {
			if( elem.limit == -1 )
				continue;

			switch( elem.type ) {
			case 1:
				if( shapepenalty(elem) != 0 )
					isok = false;
				break;
			case 2:
				if( shapepenalty(elem) != 0 )
					isok = false;
				break;
			}
			if( !isok )
				break;
		}
		return	isok;
	}
	
	public	void	updateShapeConstraints( ArrayList<Rectangle> reclist ) {
		for( ConstraintElem elem : shapeconstraintlist ) {
			switch( elem.type ) {
			case 1:
				elem.setCount(gridfield.getShapeCount( reclist, elem.lside, elem.sside ));
				break;
				
			case 2:
				elem.setCount(gridfield.getShapeCount( reclist, elem.area, elem.areacmp ));
			}
		}
	}
	
	private	JPanel	makeShapeControlPanel() {
		JPanel panel = new JPanel();
		panel.setLayout( new  BoxLayout(panel,BoxLayout.X_AXIS) );
	
		sizecontrolpanel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		panel.add(sizecontrolpanel);
		
		shapecontrolpanel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		panel.add(shapecontrolpanel);
		
		return	panel;
	}
	
	private 	ConstraintElem	addAreaConstraint( JPanel pt, int ar, String arch, String cmp ) {
		ConstraintElem elem = new ConstraintElem( pt,ar, arch, cmp );
		sizecontrolpanel.add( elem );
		sizecontrolpanel.validate();
		shapeconstraintlist.add(elem);
		
		return	elem;
	}
	
	private 	ConstraintElem	addShapeConstraint( JPanel pt, int ls, int ss, String cmp ) {
		ConstraintElem elem = new ConstraintElem( pt, ls, ss, cmp );
		shapecontrolpanel.add(elem);
		shapecontrolpanel.validate();
		shapeconstraintlist.add(elem);
		
		return	elem;
	}
	
	private void clearAllConstraints() {
		for( ConstraintElem elem : shapeconstraintlist ) {
			elem.field.setText("--");
			elem.reread();
		}
	}
		
	private void zeroAllConstraints() {
		for( ConstraintElem elem : shapeconstraintlist ) {
			elem.field.setText("0");
			elem.reread();
		}
	}
	
	public	ArrayList<String>	toStringShapeConstraints() {
		ArrayList<String> list = new ArrayList<String>();
		
		for( ConstraintElem elem : shapeconstraintlist ) {
			if( elem.limit == -1 )
				continue;
			switch( elem.type ) {
			case 1:
				list.add( String.format("RectLS %d %d %s %d %b", 
						elem.lside, elem.sside, elem.cmp, elem.limit ) );
				break;
			case 2:
				list.add( String.format("RectAR %s %d %s %d %b", 
						elem.areacmp, elem.area, elem.cmp, elem.limit ) );
				break;
			}
		}
		
		return	list;
	}

	public	int	shapeeval( ArrayList<Rectangle> reclist ) {
		updateShapeConstraints(reclist);
		int	val = 0;
		for( ConstraintElem elem : shapeconstraintlist ) {
			if( elem.limit == -1 )
				continue;
			int	sz;
			switch( elem.type ) {
			case 1:						// 形状制約
				sz = elem.lside * elem.sside;
				val += sz * shapepenalty( elem );
				break;
			case 2:						// 面積制約			
				if( elem.area > 0 ) {
					if( elem.areacmp.equals(">=") ) {	// サイズオーバー
						val += sizeoverpenalty( elem, reclist );
					} else if( elem.areacmp.equals("=") ) {	// 指定サイズ
						int	v = shapepenalty( elem );
						val += elem.area * v;
					} else {
						int	v = shapepenalty( elem );
						val += elem.area * v;
					}
				}
			}
		}

		return	val;
	}
	
	public	ArrayList<Rectangle>	getshapeerrorrecs( ArrayList<Rectangle> reclist ) {
		updateShapeConstraints(reclist);
		ArrayList<Rectangle> list = new ArrayList<Rectangle>();
		
		for( ConstraintElem elem : shapeconstraintlist ) {
			if( elem.limit == -1 )
				continue;
			switch( elem.type ) {
			case 1:						// 形状制約
				if( shapepenalty( elem ) == 0 )
					break;
				for( Rectangle r : reclist ) {
					int rl = Math.max(r.width,r.height);
					int rs = Math.min(r.width,r.height);
					if( rl == elem.lside && rs == elem.sside )
						list.add(r);
				}
			case 2:						// 面積制約			
				if( elem.area > 0 ) {
					if( elem.areacmp.equals(">=") ) {	// サイズオーバー
						if( sizeoverpenalty( elem, reclist ) <= 0 )
							break;
						for( Rectangle r : reclist ) {
							int	rs = r.width*r.height;
							if( rs > elem.area )
								list.add(r);
						}
					} else if( elem.areacmp.equals("=") ) {
						for( Rectangle r : reclist ) {
							int	rs = r.width*r.height;
							if( rs == elem.area )
								list.add(r);
						}						
					} else {
						// とりあえず無視
					}

				}
			}
		}

		return	list;	
	}
	
	private	int		shapepenalty( ConstraintElem elem ) {
		if( elem.cmp.equals("=") ) {
			return	Math.abs( elem.count - elem.limit );
		} else if( elem.cmp.equals("<=") ) {
			if( elem.count >= elem.limit )
				return	elem.count - elem.limit;
		} else if( elem.count <= elem.limit ) {
			return	elem.limit - elem.count;	
		}
		return	0;
	}

	private	int		sizeoverpenalty( ConstraintElem elem, ArrayList<Rectangle> reclist  ) {
		int cnt = 0;
		for( Rectangle rec : reclist ) {
			if( rec.width * rec.height >= elem.area )
				++cnt;
		}
		if( elem.cmp.equals("<=") ) {
			if( cnt <= elem.limit )
				return	0;
		} else if( elem.cmp.equals("=") ) {
			if( cnt == elem.limit )
				return	0;
			if( cnt <= elem.limit )
				return	elem.area * (elem.limit - cnt );
		} else {
			if( cnt >= elem.limit )
				return	0;
			
			int[] sizes = new int[reclist.size()-cnt];
			int i = 0;
			for( Rectangle rec : reclist ) {
				if( elem.area > rec.width * rec.height )
				sizes[i++] = elem.area - rec.width * rec.height;
			}			
			Arrays.sort(sizes);
			
			int val = 0;
			for( int j=0; j<elem.limit - cnt; ++j )
				val += sizes[j];

			return	val;
		}
		
		int[] sizes = new int[cnt];
		int	i=0;
		for( Rectangle rec : reclist ) {
			if( rec.width * rec.height >= elem.area )
				sizes[i++] = rec.width * rec.height;
		}
		Arrays.sort(sizes);
		int	val = 0;
		for( int j=elem.limit; j<sizes.length; ++j )
			val += sizes[j];
		
		return	val;
	}
	
	public	void	allreread() {
		for( ConstraintElem elem : shapeconstraintlist )
			elem.reread();
	}
	
	public	void  delelems() {
		ArrayList<ConstraintElem> dellist = new ArrayList<ConstraintElem>();
		for( ConstraintElem elem : shapeconstraintlist ) {
			if( elem.clicked ) {
				dellist.add(elem);
				elem.parent.remove(elem);
				elem.parent.validate();
				elem.parent.repaint();
			}
		}
		for( ConstraintElem delm : dellist ) {
			shapeconstraintlist.remove(delm);
		}
		
	}

	public	void  delallelems() {
		ArrayList<ConstraintElem> dellist = new ArrayList<ConstraintElem>();
		for( ConstraintElem elem : shapeconstraintlist ) {
			dellist.add(elem);
			elem.parent.remove(elem);
			elem.parent.validate();
			elem.parent.repaint();
		}
		for( ConstraintElem delm : dellist ) {
			shapeconstraintlist.remove(delm);
		}
	}
	
	//	制約要素パネル
	class ConstraintElem extends JPanel {
		private static final long serialVersionUID = 1L;
		boolean		set;
		boolean		clicked;
		JPanel			parent;
		int				type;			// 1: ls, ss, ch     2: size, ch, ch
		int				lside, sside;
		int				area;			// 面積
		JTextField		areafield;
		String			areacmp;		// "=", "<=", ">="
		JTextField		field;
		String			cmp;			// "=", "<=", ">="
		int				limit;			//
		JLabel			countlabel;
		int				count;			// 実際の数

		ConstraintElem( JPanel pt, int ss, int ls, String ch ) {
			parent = pt;
			JLabel		shlabel;
			
			setBorder(new EtchedBorder(EtchedBorder.LOWERED));
			
			type  = 1;
			lside = Math.max(ss,ls);
			sside = Math.min(ss,ls);
			cmp = ch;
			
			String	lstr = "("+lside+"x"+sside+")";
			shlabel = new JLabel( lstr );

			add(shlabel);
			countlabel = new JLabel( "--" );
			countlabel.setOpaque(true);
			add(countlabel);
			add(new JLabel( cmp ));
			field = new JTextField();
			field.setText("-");
			limit = -1;
			field.setColumns(2);
			add(field);
			
			field.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {	reread();	}
				});		
			
			addMouseListener(madapter);
		}

		ConstraintElem( JPanel pt, int ar, String arch, String ch ) {
			parent	= pt;
			
			setBorder(new EtchedBorder(EtchedBorder.LOWERED));
					
			type  = 2;
			areacmp = arch;
			area = ar;
			cmp = ch;
			
			add(new JLabel( "(area"+areacmp+area+")" ) );
				
			countlabel = new JLabel( "--" );
			countlabel.setOpaque(true);
			add(countlabel);
			add(new JLabel( cmp ));
			field = new JTextField();
			field.setText("-");
			limit = -1;
			field.setColumns(2);
			add(field);
			
			field.addActionListener(
				new ActionListener(){
					public void actionPerformed(ActionEvent e) {	reread();	}
				});
		
			addMouseListener(madapter);
		}

		MouseAdapter madapter = new MouseAdapter() {
			@Override
			public	void mouseClicked(MouseEvent e) {
				clicked = !clicked;
				if( clicked ) {
					setBackground(elemclkcolor);
				} else {
					setBackground(set?elemsetcolor:null);
				}
				setOpaque(true);
			}
		};
		
		void	setCount( int n )	{	
			count = n;	
			if( limit != -1 ) {
				countlabel.setText(""+count);
			}
		}
		
		void	reread() {
			String str = field.getText();
			set = true;
			setBackground(elemsetcolor);
			setOpaque(true);
			try {
				limit = new Integer(str);
			}catch(NumberFormatException ex){
				limit = -1;
				countlabel.setText("--");
			}
		}
	}

	@Override
	public void stateChanged(ChangeEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void itemStateChanged(ItemEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		
	}
}
